PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Protected Member Functions | List of all members
PQueue< T > Class Template Reference

This template class maps the PAbstractList to a specific object type, and adds functionality that allows the list to be used as a first in first out queue. More...

`#include <lists.h>`

Inheritance diagram for PQueue< T >:
[legend]
Collaboration diagram for PQueue< T >:
[legend]

## Public Member Functions
Construction
| PQueue ()
| Create a new, empty, queue. More...
Overrides from class PObject
virtual PObject * | Clone () const
| Make a complete duplicate of the list. More...
New functions for class
virtual void | Enqueue (T *obj)
| Add a new object to the queue. More...
virtual T * | Dequeue ()
| Remove an object that was added to the queue. More...
Public Member Functions inherited from PAbstractList
virtual Comparison | Compare (const PObject &obj) const
| Get the relative rank of the two lists. More...
PINLINE | PAbstractList ()
| Create a new, empty, list. More...
virtual PBoolean | SetSize (PINDEX newSize)
| This function is meaningless for lists. More...
virtual PINDEX | Append (PObject *obj)
| Append a new object to the collection. More...
virtual void | Prepend (PObject *obj)
| Append a new object to the collection. More...
virtual PINDEX | Insert (const PObject &before, PObject *obj)
| Insert a new object immediately before the specified object. More...
virtual P_DEPRECATED PINDEX | InsertAt (PINDEX index, PObject *obj)
| Insert a new object at the specified ordinal index. More...
virtual PBoolean | Remove (const PObject *obj)
| Remove the object from the collection. More...
virtual PObject * | RemoveHead ()
| Remove the head object from the list. More...
virtual PObject * | RemoveTail ()
| Remove the tail object from the list. More...
virtual P_DEPRECATED PObject * | RemoveAt (PINDEX index)
| Remove the object at the specified ordinal index from the collection. More...
virtual P_DEPRECATED PBoolean | SetAt (PINDEX index, PObject *val)
| Set the object at the specified ordinal position to the new value. More...
virtual P_DEPRECATED PBoolean | ReplaceAt (PINDEX index, PObject *val)
| Set the object at the specified ordinal position to the new value. More...
virtual P_DEPRECATED PObject * | GetAt (PINDEX index) const
| Get the object at the specified ordinal position. More...
virtual PINDEX | GetObjectsIndex (const PObject *obj) const
| Search the collection for the specific instance of the object. More...
virtual PINDEX | GetValuesIndex (const PObject &obj) const
| Search the collection for the specified value of the object. More...
Public Member Functions inherited from PCollection
| PCollection (PINDEX initialSize=0)
| Create a new collection. More...
virtual void | PrintOn (ostream &strm) const
| Print the collection on the stream. More...
virtual void | RemoveAll ()
| Remove all of the elements in the collection. More...
PINLINE void | AllowDeleteObjects (PBoolean yes=true)
| Allow or disallow the deletion of the objects contained in the collection. More...
void | DisallowDeleteObjects ()
| Disallow the deletion of the objects contained in the collection. More...
Public Member Functions inherited from PContainer
| PContainer (PINDEX initialSize=0)
| Create a new unique container. More...
| PContainer (const PContainer &cont)
| Create a new refernce to container. More...
PContainer & | operator= (const PContainer &cont)
| Assign one container reference to another. More...
virtual | ~PContainer ()
| Destroy the container class. More...
virtual PINDEX | GetSize () const
| Get the current size of the container. More...
PBoolean | SetMinSize (PINDEX minSize)
| Set the minimum size of container. More...
virtual PBoolean | IsEmpty () const
| Determine if the container is empty. More...
PBoolean | IsUnique () const
| Determine if container is unique reference. More...
virtual PBoolean | MakeUnique ()
| Make this instance to be the one and only reference to the container contents. More...
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Member Functions
| PQueue (int dummy, const PQueue *c)
Protected Member Functions inherited from PAbstractList
PINLINE PObject & | GetReferenceAt (PINDEX index) const
PListElement * | FindElement (PINDEX index) const
PListElement * | FindElement (const PObject &obj, PINDEX *index) const
void | InsertElement (PListElement *element, PObject *obj)
PObject * | RemoveElement (PListElement *element)
Protected Member Functions inherited from PCollection
PINLINE | PCollection (int dummy, const PCollection *coll)
| Constructor used in support of the Clone() function. More...
Protected Member Functions inherited from PContainer
| PContainer (int dummy, const PContainer *cont)
| Constructor used in support of the Clone() function. More...
| PContainer (PContainerReference &reference)
| Construct using static PContainerReference. More...
virtual void | DestroyContents ()=0
| Destroy the container contents. More...
virtual void | AssignContents (const PContainer &c)
| Copy the container contents. More...
void | CopyContents (const PContainer &c)
| Copy the container contents. More...
void | CloneContents (const PContainer *src)
| Create a duplicate of the container contents. More...
void | Destruct ()
| Internal function called from container destructors. More...
virtual void | DestroyReference ()
| Destroy the PContainerReference instance. More...
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Additional Inherited Members
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Protected Types inherited from PAbstractList
typedef PListElement | Element
Protected Attributes inherited from PAbstractList
PListInfo * | info
Friends inherited from PObject

## Detailed Description

### template<class T>
class PQueue< T >

This template class maps the PAbstractList to a specific object type, and adds functionality that allows the list to be used as a first in first out queue.

The functions in this class primarily do all the appropriate casting of types.

By default, objects placed into the set will T be deleted when removed or when all references to the set are destroyed. This is different from the default on most collection classes.

Note that if templates are not used the `PDECLARE_QUEUE` macro will simulate the template instantiation.

## Constructor & Destructor Documentation

template<class T>

PQueue< T >::PQueue | ( |  | ) |
| inline

Create a new, empty, queue.

Note that by default, objects placed into the queue will not be deleted when removed or when all references to the queue are destroyed. This is different from the default on most collection classes.

Referenced by PQueue< PXML >::Clone().

template<class T>

PQueue< T >::PQueue | ( | int | dummy,
|  | const PQueue< T > * | c
| ) |  |
| inline protected

## Member Function Documentation

template<class T>

virtual PObject* PQueue< T >::Clone | ( |  | ) | const
| inline virtual

Make a complete duplicate of the list.

Note that all objects in the array are also cloned, so this will make a complete copy of the list.

Reimplemented from PObject.

template<class T>

virtual T* PQueue< T >::Dequeue | ( |  | ) |
| inline virtual

Remove an object that was added to the queue.

Returns
  first object added to the queue or NULL if queue empty.

template<class T>

virtual void PQueue< T >::Enqueue | ( | T * | obj | ) |
| inline virtual

Add a new object to the queue.

This places a new link at the "tail" of the list, which is the "in" side of the queue.

Parameters

  obj | Object to add to the queue.

The documentation for this class was generated from the following file:

- lists.h